#include "raii.hpp"
#include <iostream>
#include <memory>

///
/// `Noisy` member function implementations
///

void Noisy::speak(std::string const& what) const
{
    std::cout << identity << " (" << this << "): " << what << "\n";
}

Noisy::Noisy(std::string s)
        : identity(std::move(s))
{
    speak("string constructor");
}

Noisy::Noisy()
        : Noisy("<anonymous>")
{
    speak("default constructor");
}

Noisy::Noisy(Noisy const& that)
        : identity("copy of " + that.identity)
{
    speak("copy constructor");
}

Noisy& Noisy::operator=(Noisy const& that)
{
    identity = "copy of " + that.identity + " née " + identity;
    return *this;
}

Noisy::~Noisy()
{
    speak("destructor");
}
