#pragma once

#include <string>

struct Noisy
{
    ///
    /// Data members ("fields")
    ///

    std::string identity;

    ///
    /// Special function members
    ///

    // Default constructor, used when no parameter is given.
    Noisy();
    // Constructs from a `std::string` identity.
    explicit Noisy(std::string);

    // Copy constructor, used to initialize a new `Noisy` from an existing one.
    Noisy(Noisy const&);
    // Copy-assignment operator, used to copy between `Noisy` objects.
    Noisy& operator=(Noisy const&);

    // Destructor, called when object goes out of scope.
    ~Noisy();

    ///
    /// Function members ("methods")
    ///

    // Helper for printing what is happening to whom (called by the special
    // members).
    void speak(std::string const& what) const;
};

