#include <stdio.h>
#include <stdlib.h>

struct posn
{
    double x;
    double y;
};

struct circle
{
    struct posn center;
    double radius;
};

void scale_circle_broken(struct circle circ, double factor)
{
    circ.radius *= factor;
}

void example1_broken()
{
    struct circle c = {
            .center = { .x = 3, .y = 4 },
            .radius = 6
    };

    scale_circle_broken(c, 2);

    printf("%g\n", c.radius);
}

void scale_circle_fixed(struct circle* circ, double factor)
{
    circ->radius *= factor;
}

void example1_fixed()
{
    struct circle c = {
            .center = { .x = 3, .y = 4 },
            .radius = 6
    };

    scale_circle_fixed(&c, 2);

    printf("%g\n", c.radius);
}

void example2_broken()
{
    struct circle c1 = {
            .center = { .x = 3, .y = 4 },
            .radius = 6
    };
    struct circle c2 = c1;

    c2.radius *= 2;

    printf("%g\n", c1.radius);
}

void example2_fixed()
{
    struct circle c1 = {
            .center = { .x = 3, .y = 4 },
            .radius = 6
    };
    struct circle* c2 = &c1;

    c2->radius *= 2;

    printf("%g\n", c1.radius);
}

int main()
{
    example1_broken();
    example1_fixed();
    example2_broken();
    example2_fixed();

    struct circle* cp = malloc(sizeof *cp);
    if (cp == NULL) return 1;
    cp->center.x = 3;
    cp->center.y = 4;
    cp->radius = 6;

    scale_circle_fixed(cp, 2);
    printf("%g\n", cp->radius);

    free(cp);
}

